#Order_check_v1_0_2.pl
#command line:
#script.pl input.txt output.txt
#input.txt - UTF-8, dictionary



use strict;


#___________________________________Rome
#Roman.pm version 1.21
#Roman - Perl module for conversion between Roman and Arabic numerals.
#http://www.cpan.org/


#Domain of valid Roman numerals is limited to less than 4000, since
#proper Roman digits for the rest are not available in ASCII.

our %roman2arabic = qw(I 1 V 5 X 10 L 50 C 100 D 500 M 1000);
my %roman_digit = qw(1 IV 10 XL 100 CD 1000 MMMMMM);
my @figure = reverse sort keys %roman_digit;
#my %roman_digit;
$roman_digit{$_} = [split(//, $roman_digit{$_}, 2)] foreach @figure;

sub isroman($) {
    my $arg = shift;
    $arg ne '' and
      $arg =~ /^(?: M{0,3})
                (?: D?C{0,3} | C[DM])
                (?: L?X{0,3} | X[LC])
                (?: V?I{0,3} | I[VX])$/ix;
}

sub arabic($) {
    my $arg = shift;
    isroman $arg or return undef;
    my($last_digit) = 1000;
    my($arabic);
    foreach (split(//, uc $arg)) {
        my($digit) = $roman2arabic{$_};
        $arabic -= 2 * $last_digit if $last_digit < $digit;
        $arabic += ($last_digit = $digit);
    }
    $arabic;
}

sub Roman($) {
    my $arg = shift;
    0 < $arg and $arg < 4000 or return undef;
    my($x, $roman);
    foreach (@figure) {
        my($digit, $i, $v) = (int($arg / $_), @{$roman_digit{$_}});
        if (1 <= $digit and $digit <= 3) {
            $roman .= $i x $digit;
        } elsif ($digit == 4) {
            $roman .= "$i$v";
        } elsif ($digit == 5) {
            $roman .= $v;
        } elsif (6 <= $digit and $digit <= 8) {
            $roman .= $v . $i x ($digit - 5);
        } elsif ($digit == 9) {
            $roman .= "$i$x";
        }
        $arg -= $digit * $_;
        $x = $i;
    }
    $roman;
}

sub roman($) {
    lc Roman shift;
}

#___________________________________Rome

my $Count1 = 1;
my $Count2 = 1;
my $Count3 = 1;


open(a, "$ARGV[0]") || die "could not open file: $!";
open(b, ">$ARGV[1]") || die "could not open file: $!";
while (<a>) {
s/[\x0A\x0D]//g;


if ($_ =~ /^[^\t\x20].*$/)
   {

    $Count1 = 1;
    $Count2 = 1;
    $Count3 = 1;

   print b "$_\n";
   }
   else
      {#____________________________


        if ($_ =~ /^.*?\{\{n1\}\}(\d+|[IVXLMDC]{1,9})\{\{\/n1\}\}.*$/)
           {
           my $str = $_;
           my $numstr = $1;
           $Count2 = 1;
           $Count3 = 1;
           my $romnum = Roman($Count1);


           if ($numstr =~ /^($Count1|$romnum)$/)
              {
              print b "$str\n";
              }
              else
                 {#||||||||||||||||

                 if ($numstr =~ /^\d+$/)
                    {
                    print b "\#$Count1$str\n";
                    }
                    else
                       {
                       print b "\#$romnum$str\n";
                       }

                 }#||||||||||||||||

           $Count1 = $Count1 + 1;
           }
    elsif ($_ =~ /^.*?\{\{n2\}\}(\d+|[IVXLMDC]{1,9})\{\{\/n2\}\}.*$/)
           {
           my $str = $_;
           my $numstr = $1;
           $Count3 = 1;
           my $romnum = Roman($Count2);



           if ($numstr =~ /^($Count2|$romnum)$/)
              {
              print b "$str\n";
              }
              else
                 {#||||||||||||||||||


                 if ($numstr =~ /^\d+$/)
                    {
                    print b "\#\#$Count2$str\n";
                    }
                    else
                       {
                       print b "\#\#$romnum$str\n";
                       }

                 }#||||||||||||||||||

           $Count2 = $Count2 + 1;
           }
    elsif ($_ =~ /^.*?\{\{n3\}\}(\d+|[IVXLMDC]{1,9})\{\{\/n3\}\}.*$/)
           {
           my $str = $_;
           my $numstr = $1;
           my $romnum = Roman($Count3);



           if ($numstr =~ /^($Count3|$romnum)$/)
              {
              print b "$str\n";
              }
              else
                 {#||||||||||||||||||


                 if ($numstr =~ /^\d+$/)
                    {
                    print b "\#\#\#$Count3$str\n";
                    }
                    else
                       {
                       print b "\#\#\#$romnum$str\n";
                       }

                 }#||||||||||||||||||

           $Count3 = $Count3 + 1;
           }
           else
              {
              print b "$_\n";
              }
      }#____________________________




            }
