#dsl_susp_links_v1_0_3.pl


use strict;
use POSIX qw(ceil floor);


if ($ARGV[0] !~ /^-[12o]$/)
   {
   print "Unrecognized switch: $ARGV[0]  (-o will show valid options).";
   }
elsif ($ARGV[0] eq '-1')
   {
   &list;
   }
elsif ($ARGV[0] eq '-2')
   {
   &susplinks;
   }
elsif ($ARGV[0] eq '-o')
   {
   print "  ________________________________\n";
   print "  Script Options:\n";
   print "  -1      GET LIST OF HEADWORDS\n";
   print "          command line:\n";
   print "          script.pl -1 input.txt list.txt\n";
   print "  -2      PROCESS SUSPENDED LINKS\n";
   print "          command line:\n";
   print "          script.pl -2 input.txt list.txt output.txt\n";
   print "  -o      SHOW OPTIONS\n";
   print "          command line:\n";
   print "          script.pl -o\n";
   print "  ________________________________\n";
   }
   else
      {
      print "Unrecognized switch: $ARGV[0]  (-o will show valid options).";
      }


      sub progressinfile {
	      my $state = shift;
	      my $max = shift;
	      my $message = shift;

	      my $percent = ($state/$max)*100;
	      $percent = floor($percent);

	      for(my $k=0;$k<$percent;$k=$k+5)
		{
		print "|";						
		}
		print "$percent% $message";
		print "\r";
	      }

sub trim {
    my $s = shift;
    $s =~ s/^\s+|\s+$//g;
    return $s;
    }

sub slash {
    my $s = shift;
    $s =~ s/\\\(/\(/g;
    $s =~ s/\\\)/\)/g;
    $s =~ s/\\\[/\[/g;
    $s =~ s/\\\]/\]/g;
    $s = trim($s);
    return $s;
    }

sub list {
         use open ':utf8';
         open(a, "$ARGV[1]") || die "could not open file: $!";
         open(b, ">$ARGV[2]") || die "could not open file: $!";
         my $filesize = -s a;
         my $countln = 0;

              while (<a>) {
              s/[\x0A\x0D]//g;
              if ($_ =~ /^\x{feff}(.*)$/)
                 {
                 $_ = $1;
                 }
              if ($_ =~ /^\#(NAME.*|INDEX_LANGUAGE.*|CONTENTS_LANGUAGE.*)$/)
                 {
                 }
              elsif ($_ =~ /^([^\t\x20].*)$/)
                    {
		    my $tmp = slash($1);
		    print b "$tmp\n";
                    }
                    else
                       {

                       }

		 $countln++;
		 if (($countln % 20) == 0)
		    {
		    my $offset = tell(a);
		    progressinfile($offset, $filesize, "");
		    }


                           } 

         my $offset = tell(a);
         progressinfile($offset, $filesize, "OK\n");

         close a;
         close b;
	 }




sub susplinks {
open(a, "$ARGV[1]") || die "could not open file: $!";
open(b, "$ARGV[2]") || die "could not open file: $!";
open(c, ">$ARGV[3]") || die "could not open file: $!";


my %hash1 = ();
my $countln = 0;

         while (<b>) {

          s/[\x0A\x0D]//g;
          if ($_ =~ /^(.{1,})$/)
	     {
	     $hash1{$1} = '';
	     }

                     }
         close b;
      my $filesize = -s a;
      while (<a>) {
      s/[\x0A\x0D]//g;

 $countln++;
 if (($countln % 2) == 0)
    {
    my $offset = tell(a);
    progressinfile($offset, $filesize, "");
    }

                     if ($_ =~ /^[^\t\x20].*$/)
                        {
                        print c "$_\n";
                        }
                        else
                           {
                           while ($_ =~ /^(.*?)<<([^<>]+?)>>(.*)$/)
                                 {
                                 print c "$1";

                                 if (exists $hash1{$2})
                                    {
                                    print c "<<$2>>";
                                    }
                                    else
                                       {
                                       print c "<<\$\$\$$2\$\$\$>>";
                                       }
                                 $_ = $3;    
                                 }
                           print c "$_\n";
                           }
                }

                 my $offset = tell(a);
                 progressinfile($offset, $filesize, "OK\n");

	  close a;
	  close c;
          }

