#replacer_v2_0_1_4.pl
#06-05-2016

#COMMAND LINE:
#script.pl -rd list input.txt output.txt
#script.pl -rt list input.txt output.txt

#script.pl -rdn list input.txt output.txt
#script.pl -rtn list input.txt output.txt

#script.pl -ra list -[A-Za-z]{1,10} input.txt output.txt
#script.pl -rs list -[A-Za-z]{1,10} input.txt output.txt

#script.pl -t input.txt output.txt
#script.pl -f list
use strict;
use warnings;

use Time::HiRes;
my $start = Time::HiRes::gettimeofday();

use open ':utf8';

local $| = 1;

package MAIN826001181{

use POSIX qw(ceil floor);


	sub Execution_time{ 
	
		my $end = Time::HiRes::gettimeofday();
		my $stat_perf = $end - $start;
		my $min = $stat_perf / 60;
		my $sec = ($stat_perf * 1000 % 60000) / 1000;
		my $elapsed = sprintf("%02u:%06.3f", $min, $sec);

		return "\n\nExecution time: " . $elapsed . " (min:sec.msec)\n";

	}



	sub buildsub {

		open(LIST, "$ARGV[1]") || die "could not open file: $!";

		$MAIN826001181::list = 'package LIST020009121{ sub SUBR920909421::replace{my $s = shift;';


			while (<LIST>) {
				s/[\x0A\x0D]//g;

				if ($_ =~ /^(\x{feff})(.*)$/)
				{
					$_ = $2;
				}

				if ($_ =~ /^(.+?)[\t\x20]+\|[\t\x20]+(.*)$/)
				{
					$MAIN826001181::list .= '$s =~ ';
					$MAIN826001181::list .= "s/\Q$1\E/\Q$2\E/g;\n";
				}
				elsif ($_ =~ /^(.+?)[\t\x20]+\|([i]{0,1})\|[\t\x20]+(.*)$/)
				{
					
					my $left = $1;
					my $right = $3;
					my $mod = $2;

					$right =~ s/(^|[^\\])([\[\]\/])/$1\\$2/gs;
					$left =~ s/(^|[^\\])([\/])/$1\\$2/gs;
					
					$MAIN826001181::list .= '$s =~ ';
					$MAIN826001181::list .= "s/$left/$right/g${mod}s;\n";


				}
				else
				{
					if ($_ =~ /^(\#.*|)$/)
					{
						$MAIN826001181::list .= "\n";
					}
					else
					{
						$MAIN826001181::list .= "$_\n";
					}
				}


			}

			$MAIN826001181::list .= ' return $s; }}';
		close LIST;

	}



	sub clearlog{
		open(ERR, ">error.log") || die "could not open file: $!";
		close(ERR);
	}

	sub onerrorexit{
		my @errtxt = @_;
		open(ERR, ">error.log") || die "could not open file: $!";
		print @errtxt;
		print ERR "@errtxt\n";
		close ERR;
		exit;
	}



	sub progressinfile {
		my $state = shift;
		my $max = shift;
		my $message = shift;
	
		my $percent = floor(($state/$max)*100);
	
		if (!defined $p::percent)
		{
		$p::percent = 0;
		}
	
		if ($percent > $p::percent)
		{
	
			for(my $k=0;$k<$percent;$k=$k+5)
			{
				print "|";
			}
		
			print "$percent% $message";
			print "\r";
	
			$p::percent = $percent;
	
		}
	
	}



	sub readtxtfile {


		open(A, "$ARGV[2]") || die "could not open file: $!";
		open(B, ">$ARGV[3]") || die "could not open file: $!";


		my $count = 0;
		my $filesize = -s A;

		while (<A>) {
			s/[\x0A\x0D]//g;


			$count++;
			if (($count % 2) == 0)
			{
				my $offset = tell(A);
				progressinfile($offset, $filesize, "");
			}


			if ($_ =~ /^(\x{feff})(.*)$/)
			{
				print B "$1";
				$_ = $2;
			}

			my $t = SUBR920909421::replace($_);


			if ($ReplaceList::errormessage)
			{
				my @errtxt;
				push @errtxt, $ReplaceList::errormessage;
				onerrorexit(@errtxt);
			}


			if (defined $t)
			{

				if ($ARGV[0] eq '-rtn')
				{
					print B $t;
				}
				else
				{
					print B "$t\n";
				}

			}
		}


		if (defined(&ReplaceList::onexit))
		{
			my @r = &ReplaceList::onexit;
			foreach(@r)
			{
				print B "$_";
			}
		}


		my $offset = tell(A);
		progressinfile($offset, $filesize, "");



		close A;
		close B;

	}



	sub func {

		open(C, ">func.txt") || die "could not open file: $!";
		print C $MAIN826001181::list;	
		close C;

	}



	sub tagslist {

		open(A, "$ARGV[1]") || die "could not open file: $!";
		open(B, ">$ARGV[2]") || die "could not open file: $!";

		sub slash {
			my $s = shift;
			$s =~ s/^<\/?(.*)>$/$1/;
			return $s;
		}

		my $count = 0;
		my $filesize = -s A;


		while (<A>) {
			s/[\x0A\x0D]//g;

			$count++;
			if (($count % 2) == 0)
			{
				my $offset = tell(A);
				progressinfile($offset, $filesize, "");
			}

			while ($_ =~ /^.*?(<[^<>]+>)(.*)$/)
			{
				$MAIN826001181::hash{$1} = '';
				$_ = $2;
			}

		} 

		my @sk = keys %MAIN826001181::hash;

		my @result = sort { slash($a) cmp slash($b) } @sk;

		foreach(@result)
		{
			$_ =~ s/\&\#44;/,/g;
			print B "$_\n";
		}

		my $offset = tell(A);
		progressinfile($offset, $filesize, 'OK');


		close A;
		close B;


	}


	sub symbrep {
		my $s = shift;


		$ARGV[2] =~ /^-([A-Za-z]{1,10})$/;
		my $name = $1;

		$s =~ s/,/\&\#44;/g;

		if ($ARGV[0] eq '-ra')
		{

			$s =~ s/(<$name>)/,$1/gi;
			$s =~ s/(<\/$name>)/$1,/gi;

			my @temparr = split(/,/, $s);

			for (my $i = 0; $i < @temparr; $i++)
			{

				if ($temparr[$i] =~ /^(<$name>)(.*)(<\/$name>)$/is)
				{
					my $ot = $1;
					my $between = $2;
					my $ct = $3;
					$between =~ s/\&\#44;/,/g;
					$between = SUBR920909421::replace($between);

					$temparr[$i] = "$ot$between$ct";
					$temparr[$i] =~ s/\&\#44;/,/g;
				}
			}

			$s = join("", @temparr);
			@temparr = ();

		}
		else
		{


			$s =~ s/(\[$name\])/,$1/gi;
			$s =~ s/(\[\/$name\])/$1,/gi;

			my @temparr = split(/,/, $s);

			for (my $i = 0; $i < @temparr; $i++)
			{

				if ($temparr[$i] =~ /^(\[$name\])(.*)(\[\/$name\])$/is)
				{
					my $ot = $1;
					my $between = $2;
					my $ct = $3;
					$between =~ s/\&\#44;/,/g;
					$between = SUBR920909421::replace($between);

					$temparr[$i] = "$ot$between$ct";
					$temparr[$i] =~ s/\&\#44;/,/g;
				}
			}

			$s = join("", @temparr);
			@temparr = ();
		}


		$s =~ s/\&\#44;/,/g;
		return $s;
	}



	sub readdicfile {


		if ($ARGV[0] =~ /^-(ra|rs)$/)
		{
			open(A, "$ARGV[3]") || die "could not open file: $!";
			open(B, ">$ARGV[4]") || die "could not open file: $!";
		}
		else
		{
			open(A, "$ARGV[2]") || die "could not open file: $!";
			open(B, ">$ARGV[3]") || die "could not open file: $!";
		}

		my $count = 0;
		my $filesize = -s A;


		my @arr1 = ();
		my $flag = 0;


		sub printarray {
			my @s = @_;
			my @hw = ();
			foreach (@s)
			{
				if ($_ =~ /^[^\t\x20].*$/)
				{
					push @hw, $_;
				}
			}
			my $art;
			foreach(@s)
			{
				if ($_ =~ /^[\t\x20].*$/)
				{
					if ($art){$art .= "\n$_"}else{$art = $_}
				}
			}

			if (@hw > 100)
			{
				my @errtxt;
				push @errtxt, "Input file does not appear to be a dictionary.\n";
				push @errtxt, "Use \'-rt\' instead of \'-rd\'\n";
				onerrorexit(@errtxt);
			}


			if ($ARGV[0] =~ /^-(ra|rs)$/)
			{
				my $res = join("\n", @hw);
				$res .= "\n";
				$res .= $art;
				$res = symbrep($res);
				print B "$res\n";
			}
			else
			{
				my $res = join("\n", @hw);
				$res .= "\n";
				$res .= $art;

				$res = SUBR920909421::replace($res);


				if ($ReplaceList::errormessage)
				{
					my @errtxt;
					push @errtxt, $ReplaceList::errormessage;
					onerrorexit(@errtxt);
				}

				if (defined $res){

					if ($ARGV[0] eq '-rdn')
					{
						print B $res;	
					}
					else
					{
						print B "$res\n";
					}
				}

			}

		}



		while (<A>) {
			s/[\x0A\x0D]//g;

			$count++;
			if (($count % 2) == 0)
			{
				my $offset = tell(A);
				progressinfile($offset, $filesize, "");
			}


			if ($_ =~ /^(\x{feff})(.*)$/)
			{
				print B "$1";
				$_ = $2;
			}


			if ($_ =~ /^\#(NAME.*|INDEX_LANGUAGE.*|CONTENTS_LANGUAGE.*|ICON_FILE.*|INCLUDE.*|SOURCE_CODE_PAGE.*)$/)
			{
				print B "\#$1\n";
			}
			elsif (($_ =~ /^$/) && (@arr1 == 0))
			{
				print B "$_\n";
			}
			elsif (($_ =~ /^[\t\x20].*$/) && (@arr1 == 0))
			{
				print B "$_\n";
			}
			elsif ($_ =~ /^[^\t\x20].*$/)
			{

				if (($flag == 0) || ($flag == 2))
				{
					if (@arr1 > 0)
					{
						printarray(@arr1);
					}
					@arr1 = ();
					push @arr1, $_;
				}
				else
				{
					push @arr1, $_;
				} 

				$flag = 1;
			}
			else
			{
				push @arr1, $_;
				$flag = 2;

			}

		}


		if (@arr1 > 0)
		{
			printarray(@arr1);
			@arr1 = ();
		}


		if ($ARGV[0] =~ /^-(rd|rdn)$/)
		{

			if (defined(&ReplaceList::onexit))
			{
				my @r = &ReplaceList::onexit;
				foreach(@r)
				{
					print B "$_";
				}
			}
		}

		my $offset = tell(A);
		progressinfile($offset, $filesize, "");




		close A;
		close B;

	}




	&clearlog;

	if ((@ARGV == 4) && ($ARGV[0] =~ /^-(rd|rdn)$/))
	{

		&buildsub;

		eval $MAIN826001181::list;

		if ($@)
		{
			onerrorexit($@);
		}

		&readdicfile;
		print &Execution_time;

	}
	elsif ((@ARGV == 4) && ($ARGV[0] =~ /^-(rt|rtn)$/))
	{

		&buildsub;

		eval $MAIN826001181::list;

		if ($@)
		{
			onerrorexit($@);
		}

		&readtxtfile;
		print &Execution_time;

	}
	elsif ((@ARGV == 3) && ($ARGV[0] eq '-t'))
	{
		&tagslist;
		print &Execution_time;
	}
	elsif ((@ARGV == 2) && ($ARGV[0] eq '-f'))
	{
		&buildsub;

		eval $MAIN826001181::list;

		if ($@)
		{
			onerrorexit($@);
		}

		&func;
		print &Execution_time;

	}
	elsif ((@ARGV == 5) && ($ARGV[0] =~ /^-(ra|rs)$/) && ($ARGV[2] =~ /^-[A-Za-z]{1,10}$/))
	{

		&buildsub;

		eval $MAIN826001181::list;

		if ($@)
		{
			onerrorexit($@);
		}

		&readdicfile;
		print &Execution_time;


	}
	else
	{
		my @errtxt;
		push @errtxt, "\t________________________________\n";
		push @errtxt, "\n";
		push @errtxt, "\tInvalid command line.\n";
		push @errtxt, "\t________________________________\n";
		onerrorexit(@errtxt);
	}



}


