#sortdsltags_v1_0_5.pl
#Command line:
#script.pl input.txt output.txt


use Time::HiRes;
my $start = Time::HiRes::gettimeofday();

use strict;
use warnings;
use POSIX qw(ceil floor);
use open ':utf8';

local $| = 1;

open(A, "$ARGV[0]") || die "could not open file: $!";
open(B, ">$ARGV[1]") || die "could not open file: $!";


if (@ARGV != 2)
{
	print "  ________________________________\n";
	print "  Invalid command line.\n";
	print "  ________________________________\n";
	exit;
}

my $count = 0;
my $filesize = -s A;


my @arr1 = ();
my $flag = 0;
my @tags = ();



sub trim{
	my $s = shift;

	$s =~ s/\[(c) +[a-z]+\]/\L$1/i;
	$s =~ s/\[lang +id=\d+?\]/lang/i;
	$s =~ s/\[lang +name=[^\[\]]+?\]/lang/i;
	$s =~ s/\[\/?(.+)\]/\L$1/i;

	return $s;
}



sub sorttags{
	my @arr = @_;

	my @m = ();

	foreach my $a (@arr)
	{
		my ($n, $t) = split(/:/, $a);

		my $ctn = 0;
		foreach my $b (@tags)
		{

			if (($b->[0] > $n) and (trim($b->[1]) eq trim($t)))
			{
				$ctn = $b->[0];
				last;
			}

		}

		push @m, [($ctn, $t)];

	}

	my @sorted = sort {$b->[0] <=> $a->[0]} @m;

	my @r = ();

	foreach my $e (@sorted)
	{
		push @r, $e->[1];
	}

	return @r;

}



sub sorttags_reverse{
	my @arr = @_;

	my @m = ();

	foreach my $a (@arr)
	{
		my ($n, $t) = split(/:/, $a);

		my $ctn = 0;
		foreach my $b (@tags)
		{


			if (($b->[0] > $n) and (trim($b->[1]) eq trim($t)))
			{
				$ctn = $b->[0];
				last;
			}

		}

		push @m, [($ctn, $t)];

	}

	my @sorted = sort {$a->[0] <=> $b->[0]} @m;

	my @r = ();

	foreach my $e (@sorted)
	{
		push @r, $e->[1];
	}

	return @r;

}



sub meth1 {
	my $s = shift;

	$s =~ s/\\\[/\\\&\#91\;/g;
	$s =~ s/\\\]/\\\&\#93\;/g;
	$s =~ s/\[((?:br|s|t|m|m\d|ref|url|video|preview|ref\x20[^\r\n\]]+)|\/(?:m|s|t|ref|url|video|preview))\]/&#91;$1&#93;/gis;



#|||||||||||||||||||| START SORTING OPENING TAGS ||||||||||||||||||||

	my $count = 0;

	@tags = ();

	my $t = $s;

	while ($t =~ /^.*?(\[\/?(?:[cbipu]|sup|url|sub|ex|\'|\*|\!trs|lang|lang +id=\d+?|lang +name=[^\[\]]+|com|c +[a-z]{2,30}|trn\d?)\])(.*)$/si)
	{


		my $m1 = $1;
		my $m2 = $2;

		$count++;

		if ($m1 =~ /^\[\/[^\n]*\]$/s)
		{
			push @tags, [($count, $m1)];
		}

		$t = $m2;

	}

	my @arr = ();

	$count = 0;

	while ($s =~ /^(.*?)(\[\/?(?:[cbipu]|sup|url|sub|ex|\'|\*|\!trs|lang|lang +id=\d+?|lang +name=[^\[\]]+|com|c +[a-z]{2,30}|trn\d?)\])(.*)$/si)
	{


		my $m1 = $1;
		my $m2 = $2;
		my $m3 = $3;

	

		if ($m1 ne '')
		{
			push @arr, [($m1)];
		}



		if ((@arr > 0) and ($arr[$#arr][0] =~ /^\d+:\[[^\/\n][^\n]*\]$/s) and ($m2 =~ /^\[[^\/\n][^\n]*\]$/s))
		{
			$count++;
			push @{ $arr[$#arr] }, "$count:$m2";
		}
		else
		{


			if ($m2 =~ /^\[[^\/\n][^\n]*\]$/s)
			{
				$count++;
				push @arr, [("$count:$m2")];
			}
			elsif ($m2 =~ /^\[\/[^\n]*\]$/s)
			{
				$count++;
				push @arr, [($m2)];
			}
			else
			{
				push @arr, [($m2)];
			}

		}

		$s = $m3;

	}


	push @arr, [($s)];

	$s = '';

	foreach my $e (@arr)
	{


		my @r = @{ $e };


		if (@r > 1)
		{
			@r = sorttags(@r);
		}
		else
		{


			if ($r[0] =~ /^\d+:(\[[^\/\n][^\n]*\])$/s)
			{
				$r[0] = $1;
			}

		}


		$s .= join("", @r);

	}

#|||||||||||||||||||| END SORTING OPENING TAGS ||||||||||||||||||||

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

#|||||||||||||||||||| START SORTING CLOSING TAGS ||||||||||||||||||


	$count = 0;

	@tags = ();

	$t = $s;

	while ($t =~ /^(.*)(\[\/?(?:[cbipu]|sup|url|sub|ex|\'|\*|\!trs|lang|lang +id=\d+?|lang +name=[^\[\]]+|com|c +[a-z]{2,30}|trn\d?)\]).*?$/si)
	{


		my $m1 = $1;
		my $m2 = $2;


		$count++;

		if ($m2 =~ /^\[[^\n\/]*\]$/s)
		{
			push @tags, [($count, $m2)];
		}

		$t = $m1;

	}



	@arr = ();

	$count = 0;

	while ($s =~ /^(.*)(\[\/?(?:[cbipu]|sup|url|sub|ex|\'|\*|\!trs|lang|lang +id=\d+?|lang +name=[^\[\]]+|com|c +[a-z]{2,30}|trn\d?)\])(.*?)$/si)
	{


		my $m1 = $1;
		my $m2 = $2;
		my $m3 = $3;


		if ($m3 ne '')
		{
			push @arr, [($m3)];
		}



		if ((@arr > 0) and ($arr[$#arr][0] =~ /^\d+:\[\/[^\n]*\]$/s) and ($m2 =~ /^\[\/[^\n]*\]$/s))
		{
			$count++;
			push @{ $arr[$#arr] }, "$count:$m2";
		}
		else
		{

			if ($m2 =~ /^\[\/[^\n]*\]$/s)
			{
				$count++;
				push @arr, [("$count:$m2")];
			}
			elsif ($m2 =~ /^\[[^\/\n][^\n]*\]$/s)
			{
				$count++;
				push @arr, [($m2)];
			}
			else
			{
				push @arr, [($m2)];
			}

		}

		$s = $m1;

	}


	push @arr, [($s)];

	$s = '';

	foreach my $e (@arr)
	{


		my @r = @{ $e };

		if (@r > 1)
		{


			@{ $e } = sorttags_reverse(@r);
		}
		else
		{

			if ($r[0] =~ /^\d+:(\[\/[^\n]*\])$/s)
			{
				@{ $e }[0] = $1;
			}

		}


	}

	@arr = reverse(@arr); 

	foreach my $e (@arr)
	{

		my @r = @{ $e };

		$s .= join("", @r);

	}

#|||||||||||||||||||| END SORTING CLOSING TAGS ||||||||||||||||||


	$s =~ s/\&\#91\;/\[/g;
	$s =~ s/\&\#93\;/\]/g;

	return $s;

}



sub progressinfile {
	my $state = shift;
	my $max = shift;
	my $message = shift;

	my $percent = floor(($state/$max)*100);

	if (!defined $p::percent)
	{
	$p::percent = 0;
	}

	if ($percent > $p::percent)
	{

		for(my $k=0;$k<$percent;$k=$k+5)
		{
			print "|";
		}
	
		print "$percent% $message";
		print "\r";

		$p::percent = $percent;

	}

}





sub printarray {

	my @s = @_;
	my @hw = ();
	foreach (@s)
	{
		if ($_ =~ /^[^\t\x20].*$/)
		{
			push @hw, $_;
		}
	}


	my $art = "";
	foreach(@s)
	{
		if ($_ =~ /^[\t\x20].*$/)
		{
			$art = "$art$_\n";
		}

	}


	if (@hw > 100)
	{
		print "Input file does not appear to be a dictionary.\n";
		exit;
	}


	my $res = join("\n", @hw);
	$res .= "\n";
	$res .= $art;
	$res = meth1($res);
	print B "$res\n";


}



while (<A>) {
	s/[\x0a\x0d]//g;

	$count++;
	if (($count % 2) == 0)
	{
		my $offset = tell(A);
		progressinfile($offset, $filesize, "");
	}



	if ($_ =~ /^(\x{feff})(.*)$/)
	{
		print B "$1";
		$_ = $2;
	}


	if ($_ =~ /^\#(NAME.*|INDEX_LANGUAGE.*|CONTENTS_LANGUAGE.*|ICON_FILE.*|INCLUDE.*|SOURCE_CODE_PAGE.*)$/)
	{
		print B "\#$1\n";
	}
	elsif (($_ =~ /^$/) && (@arr1 == 0))
	{
		print B "$_\n";
	}
	elsif (($_ =~ /^[\t\x20].*$/) && (@arr1 == 0))
	{
		print B "$_\n";
	}
	elsif ($_ =~ /^[^\t\x20].*$/)
	{

		if (($flag == 0) || ($flag == 2))
		{
			if (@arr1 > 0)
			{
				printarray(@arr1);
			}
			@arr1 = ();
			push @arr1, $_;
		}
		else
		{
			push @arr1, $_;
		} 

		$flag = 1;
	}
	else
	{
		push @arr1, $_;
		$flag = 2;

	}

}


if (@arr1 > 0)
{
	printarray(@arr1);
	@arr1 = ();
}

my $offset = tell(A);
progressinfile($offset, $filesize, "");

my $end = Time::HiRes::gettimeofday();
my $stat_perf = $end - $start;
my $min = $stat_perf / 60;
my $sec = ($stat_perf * 1000 % 60000) / 1000;
my $elapsed = sprintf("%02u:%06.3f", $min, $sec);
print "\nExecution time: " . $elapsed . " (min:sec.msec)\n";

close A;
close B;
