﻿#stressmark_v1_0_4.pl
#COMMAND LINE:
#script.pl -a input.txt output.txt
#script.pl -b input.txt output.txt
#script.pl -h input.txt output.txt
#script.pl -text input.txt output.txt

#LISTS/*.list

use strict;
use utf8;
use open ':utf8';
use File::Find;
use POSIX qw(ceil floor);




if ((@ARGV == 3) && ($ARGV[0] =~ /^-(a|h|b|text)$/))
   {

   }
   else
      {
      print "  ________________________________\n";
      print "  Invalid command line.\n";
      print "  ________________________________\n";
      exit;
      }



open(a, "$ARGV[1]") || die "could not open file: $!";
open(b, ">$ARGV[2]") || die "could not open file: $!";
#open(c, ">log.txt") || die "could not open file: $!";


my %hash = ();




sub readlists{ #__________________________

my @file = ();


sub trim($)
{
	my $string = shift;
        $string =~ s/\[\'\]//g;
        $string =~ s/\[\/\'\]//g;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}


find(sub { push @file, $_ }, 'Lists');

foreach (@file)
        {#+++++++++++++++++++++


if ($_ =~ /^(.+\.list)$/)
   {#- - - - - -

   my $fn = $1;


open(in, "Lists/$1") || die "could not open file: $!";


my $count = 0;
my $filesize = -s in;

print "reading $fn\n";


while (<in>) {# - . - . -
s/[\x0A\x0D]//g;


#\\\\\\\\\\\\\\\\\\\\
$count++;
if (($count % 20) == 0)
   {
my $offset = tell(in);
   progressinfile($offset, $filesize, "");
   }
#////////////////////



if ($_ =~ /^(\x{feff})(.*)$/)
   {
   $_ = $2;
   }

   my $strl = $_;
   my $strr = $_;

   $strl = trim($strl);

   if ($strl =~ /^.+$/)
      {
      $hash{"$strl"} = $strr;
      }
   
             
             }# - . - . -


 my $offset = tell(in);
 progressinfile($offset, $filesize, "");
 print "\n\n";
close in;

   }#- - - - - -
        
        }#+++++++++++++++++++++

@file = ();
}#__________________________






sub progressinfile {#__________________________
        my $state = shift;
        my $max = shift;
        my $message = shift;

   my $percent = ($state/$max)*100;
   $percent = floor($percent);

   for(my $k=0;$k<$percent;$k=$k+5)
      {
                print "|";
      }

        print "$percent% $message";
        print "\r";

         }#__________________________




sub replace1 {#___________________

my $s = shift;


$s =~ s/«/\&\#171;/g;
$s =~ s/»/\&\#187;/g;

$s =~ s/←/\&\#8592;/g;
$s =~ s/→/\&\#8594;/g;


$s =~ s/\[p\]/«/g;
$s =~ s/\[\/p\]/»/g;

$s =~ s/\[ref\]/←/g;
$s =~ s/\[\/ref\]/→/g;

   return $s;

             }#_____________________





sub replace2 {#___________________

my $s = shift;


$s =~ s/«/\[p\]/g;
$s =~ s/»/\[\/p\]/g;

$s =~ s/←/\[ref\]/g;
$s =~ s/→/\[\/ref\]/g;


$s =~ s/\&\#171;/«/g;
$s =~ s/\&\#187;/»/g;

$s =~ s/\&\#8592;/←/g;
$s =~ s/\&\#8594;/→/g;

   return $s;

             }#_____________________






sub empt{
        my $s = shift;
        my @char_array = split(//,"$s");
        my @new = ();
        foreach(@char_array)
               {
               push @new, '*';
               }
       $s = join("", @new);
       return $s;
        }


sub task1{#_________________________

        my $s = shift;
        my $bh = shift;
        my @arr1 = ();
        my @arr2 = ();

         $s = replace1($s);

         while ($s =~ /^(.*?)(\[[a-z\/\* \d\'\!=]{1,}\]|\{\{[^\{\}]*?\}\}|<<[^<>]*?>>|«[^«»]*?»|←[^←→]*?→)(.*)$/) 
               {


               push @arr1, $1;
               push @arr1, $2;
 

               $s = $3;

               }

               push @arr1, $s;



        foreach (@arr1)
                {#. . . . . . . . . . . .

                if ($_ =~ /^(\[.*\]|\{\{.*\}\}|<<.*>>|«.*»|←.*→)$/)
                   {

                   my $tmp = $1;
                   $tmp = replace2($tmp);

                   push @arr2, $tmp;
                   }
                   else
                      {#=======================

                       my $tmp = $_;
                       $tmp = replace2($tmp);

                       $tmp = task2($tmp, $bh);


                       push @arr2, $tmp;

                      }#=======================

                }#. . . . . . . . . . . .


         $s = join("", @arr2);

         
         return $s;

         }#_________________________





sub task2{#_________________________

       my $s = shift;
       my $bh = shift;

       my @arr = ();

       while ($s =~ /^(.*?)([\p{Letter}]{4,})(.*)$/)
       {

       my $tmp = $2;

      
       my $hstr = $hash{$tmp};

       if ($hstr ne "")
          {
 

          if ($bh eq 'h')
             {
             $hstr =~ s/\[\'\]/\{\[\'\]\}/g;
             $hstr =~ s/\[\/\'\]/\{\[\/\'\]\}/g;
             }

         push @arr, "$1$hstr";


          }
          else
             {
             push @arr, "$1$tmp";
             }

        

       $s = $3;
       }
       push @arr, "$s";
       $s = join("", @arr);

       return $s;


       }#_________________________








sub main {#_________________________

my $count = 0;
my $filesize = -s a;

print "processing $ARGV[1]\n"; 

while (<a>) {# - - - - - - - -
s/[\x0A\x0D]//g;

#\\\\\\\\\\\\\\\\\\\\
$count++;
if (($count % 2) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }
#////////////////////

if ($_ =~ /^(\x{feff})(.*)$/)
   {
   print b "$1";
   $_ = $2;
   }





if ($_ =~ /^([^\t\x20].*?)[\t\x20]*$/)
   {
   my $hw =  $1;
 
      if ($ARGV[0] ne '-b')
         {#- - - - -


            $hw = task1($hw, 'h');
            print b "$hw\n";


         }#- - - - -
         else
            {
            print b "$hw\n";
            }
   }        
   else{#. . . . . . . . . . . .

       if ($ARGV[0] eq '-h')
          {
          print b "$_\n";
          }
          else
            {
            my $tmp = $_;
            $tmp = task1($tmp, 'b');
            print b "$tmp\n";
            }


      }#. . . . . . . . . . . .

            }#- - - - - - - - - -


   my $offset = tell(a);
   progressinfile($offset, $filesize, "");

}#_________________________






sub text {#_________________________

my $count = 0;
my $filesize = -s a;

print "processing $ARGV[1]\n"; 

while (<a>) {# - - - - - - - -
s/[\x0A\x0D]//g;

#\\\\\\\\\\\\\\\\\\\\
$count++;
if (($count % 2) == 0)
   {
my $offset = tell(a);
   progressinfile($offset, $filesize, "");
   }
#////////////////////

if ($_ =~ /^(\x{feff})(.*)$/)
   {
   print b "$1";
   $_ = $2;
   }


            my $tmp = $_;
            $tmp = task2($tmp, 'b');
            print b "$tmp\n";


            }#- - - - - - - - - -


   my $offset = tell(a);
   progressinfile($offset, $filesize, "");

}#_________________________







if ($ARGV[0] ne '-text')
   {

   &readlists;
   &main;

   }
   else
      {

      &readlists;
      &text;


      }




close a;
close b;
